import { Component } from "../TSX/TSX";
import { BasicEvent, EventInterface } from "@h4x/common";
export declare type $Proxy<T> = {
    get: () => T;
    set: (variable: T) => void;
    onUpdate: BasicEvent<(value?: T) => void>;
    onChange: BasicEvent<(value?: T) => void>;
};
declare const metaSymbol: unique symbol;
export declare abstract class BasicComponent<P = {}> extends Component<P> {
    private [metaSymbol];
    private attachedEventReferences;
    protected onDestroy: BasicEvent<() => void, () => void>;
    constructor();
    private setupClass;
    proxy<T = this, K extends keyof T = keyof T>(key: K): $Proxy<T[K]>;
    static var(): (target: any, key: string) => void;
    $<T = this, K extends keyof T = keyof T>(key: K): $Proxy<T[K]>;
    static bind<T extends BasicComponent<any>>(): (target: T, key: string) => void;
    static interval<T extends BasicComponent<any>>(time: number): (target: T, key: string) => void;
    static initialize<T extends BasicComponent<any>>(): (target: T, key: string) => void;
    private __init;
    private __destroy;
    /** Attach event reference to be cleaned up when the object is destroyed */
    protected ref<T extends EventInterface<any, any>>(ref: T): T;
    static normalizeClass(target: any): undefined | {
        [K: string]: boolean;
    };
}
export {};
