import { Component, TSX } from "../TSX/TSX";
import { BasicComponent } from "./BasicComponent";
export declare abstract class Fragment<T> extends BasicComponent<T & {
    fragmentList: Fragment.List<Fragment<T>>;
}> {
    private rendered;
    remove(): void;
    moveTo(pos: number): void;
    moveUp(): void;
    moveDown(): void;
    onDetached(): void;
    static attachRendered<K extends Fragment<any>>(instance: K, rendered: TSX.RenderedComponent<K>): void;
}
export declare namespace Fragment {
    class List<T extends Fragment<any>> {
        private readonly fragments;
        private component;
        get length(): number;
        get first(): TSX.RenderedComponent<T>;
        get firstInstance(): T;
        get last(): TSX.RenderedComponent<T>;
        get lastInstance(): T;
        [Symbol.iterator](): Generator<TSX.RenderedComponent<T>, void, unknown>;
        instances(): Generator<T, void, unknown>;
        get(at: number): TSX.RenderedComponent<T>;
        getInstance(at: number): T;
        addFragment(FragmentClass: new () => T, args: Omit<TSX.Props<T>, "fragmentList">, at?: number): T;
        moveFragment(rendered: TSX.RenderedComponent<T>, to?: number): T;
        /** @internal */
        removeFragment(rendered: TSX.RenderedComponent<T>): boolean;
        detachFragment(rendered: TSX.RenderedComponent<T>): boolean;
        indexOf(rendered: TSX.RenderedComponent<T>): number;
        detachAll(): void;
        destroyAll(): void;
        static attachComponent<T extends Fragment<any>>(list: List<T>, component: Container<T>): void;
    }
    namespace Container {
        interface Props<T extends Fragment<any>> extends JSX.HTMLAttributes<HTMLDivElement> {
            fragmentList: List<T>;
            [Component.Children]?: undefined;
        }
    }
    class Container<T extends Fragment<any>> extends BasicComponent<Container.Props<T>> {
        private container;
        attachContainer(instance: HTMLDivElement): void;
        attachFragment(rendered: TSX.RenderedComponent<T>, at?: number | Node): void;
        render(): JSX.Element;
    }
}
